//
//  CS52_12_4132_1230718_AshleyZeldin
//
//  Ashley Zeldin
//  CS 52 Section 4132
//  December 13, 2015
//
//  Card.cpp
//
//  Modified from the version created by Howard Stahl on April 30, 2015.
//

#include "Card.h"

namespace CS52
{
    //Constructors
    
    //ACE of HEARTS by default.
    Card::Card(Face f, Suit s) : face(f), suit(s)
    {
        
    }
    
    //Getters
    
    //Return face value of card.
    Face Card::getFace() const
    {
        return face;
    }
    
    //Return suit of card.
    Suit Card::getSuit() const
    {
        return suit;
    }
    
    //Operators
    
    //Overload insertion output operator.
    bool operator == (const Card & c1, const Card & c2)
    {
        return (c1.getFace() == c2.getFace() && c1.getSuit() == c2.getSuit());
    }
    
    //Overload equality comparison operator.
    bool operator < (const Card & c1, const Card & c2)
    {
        return (c1.getFace() < c2.getFace());
    }
    
    //Overload less-than comparison operator.
    std::ostream & operator << (std::ostream & outs, const Card & c)
    {
        switch (c.getFace())
        {
            case ACE:
                outs << "Ace of ";
                break;
            case DEUCE:
                outs << "Two of ";
                break;
            case THREE:
                outs << "Three of ";
                break;
            case FOUR:
                outs << "Four of ";
                break;
            case FIVE:
                outs << "Five of ";
                break;
            case SIX:
                outs << "Six of ";
                break;
            case SEVEN:
                outs << "Seven of ";
                break;
            case EIGHT:
                outs << "Eight of ";
                break;
            case NINE:
                outs << "Nine of ";
                break;
            case TEN:
                outs << "Ten of ";
                break;
            case JACK:
                outs << "Jack of ";
                break;
            case QUEEN:
                outs << "Queen of ";
                break;
            case KING:
                outs << "King of ";
                break;
        }
        
        switch (c.getSuit())
        {
            case SPADES:
                outs << "Spades";
                break;
            case CLUBS:
                outs << "Clubs";
                break;
            case HEARTS:
                outs << "Hearts";
                break;
            case DIAMONDS:
                outs << "Diamonds";
                break;
        }
        
        return(outs);
    }
}