//
//  CS52_12_4132_1230718_AshleyZeldin
//
//  Ashley Zeldin
//  CS 52 Section 4132
//  December 13, 2015
//
//  Card.h
//
//  Modified from the version created by Howard Stahl on April 30, 2015.
//

#ifndef CS52_12_4132_1230718_AshleyZeldin_Card_H
#define CS52_12_4132_1230718_AshleyZeldin_Card_H

#include <iostream>

namespace CS52
{
    
    enum Suit {HEARTS = 100, DIAMONDS = 200, CLUBS = 300, SPADES = 400};
    
    enum Face {ACE = 1, DEUCE = 2, THREE = 3, FOUR = 4, FIVE = 5, SIX = 6, SEVEN = 7, EIGHT = 8, NINE = 9, TEN = 10, JACK = 11, QUEEN = 12, KING = 13};
    
    class Card
    {
    public:
        
        //Constructors
        
        //ACE of HEARTS by default.
        Card(Face f = ACE, Suit s = HEARTS);
        
        //Getters
    
        //Return face value of card.
        Face getFace() const;
        
        //Return suit of card.
        Suit getSuit() const;
        
        //Operators
        
        //Overload insertion output operator.
        friend std::ostream & operator << (std::ostream & outs, const Card & c);
        
        //Overload equality comparison operator.
        friend bool operator == (const Card & c1, const Card & c2);
        
        //Overload less-than comparison operator.
        friend bool operator < (const Card & c1, const Card & c2);
        
    private:
        
        //A variable of the enumerated type corresponding to suit of card.
        Suit suit;
        
        //A variable of the enumerated type corresponding to face of card.
        Face face;
    };
    
}

#endif
