//
//  CS52_12_4132_1230718_AshleyZeldin
//
//  Ashley Zeldin
//  CS 52 Section 4132
//  December 13, 2015
//
//  Dealer.cpp
//
//  Modified from the version created by Howard Stahl on April 30, 2015.
//

#include "Dealer.h"
#include <cmath>

namespace CS52
{
    //Constructors
    
    //Default constructor.
    Dealer::Dealer()
    {
        cards[0] = Card(ACE, HEARTS);
        cards[1] = Card(ACE, CLUBS);
        cards[2] = Card(ACE, DIAMONDS);
        cards[3] = Card(ACE, SPADES);
        cards[4] = Card(DEUCE, HEARTS);
        cards[5] = Card(DEUCE, CLUBS);
        cards[6] = Card(DEUCE, DIAMONDS);
        cards[7] = Card(DEUCE, SPADES);
        cards[8] = Card(THREE, HEARTS);
        cards[9] = Card(THREE, CLUBS);
        cards[10] = Card(THREE, DIAMONDS);
        cards[11] = Card(THREE, SPADES);
        cards[12] = Card(FOUR, HEARTS);
        cards[13] = Card(FOUR, CLUBS);
        cards[14] = Card(FOUR, DIAMONDS);
        cards[15] = Card(FOUR, SPADES);
        cards[16] = Card(FIVE, HEARTS);
        cards[17] = Card(FIVE, CLUBS);
        cards[18] = Card(FIVE, DIAMONDS);
        cards[19] = Card(FIVE, SPADES);
        cards[20] = Card(SIX, HEARTS);
        cards[21] = Card(SIX, CLUBS);
        cards[22] = Card(SIX, DIAMONDS);
        cards[23] = Card(SIX, SPADES);
        cards[24] = Card(SEVEN, HEARTS);
        cards[25] = Card(SEVEN, CLUBS);
        cards[26] = Card(SEVEN, DIAMONDS);
        cards[27] = Card(SEVEN, SPADES);
        cards[28] = Card(EIGHT, HEARTS);
        cards[29] = Card(EIGHT, CLUBS);
        cards[30] = Card(EIGHT, DIAMONDS);
        cards[31] = Card(EIGHT, SPADES);
        cards[32] = Card(NINE, HEARTS);
        cards[33] = Card(NINE, CLUBS);
        cards[34] = Card(NINE, DIAMONDS);
        cards[35] = Card(NINE, SPADES);
        cards[36] = Card(TEN, HEARTS);
        cards[37] = Card(TEN, CLUBS);
        cards[38] = Card(TEN, DIAMONDS);
        cards[39] = Card(TEN, SPADES);
        cards[40] = Card(JACK, HEARTS);
        cards[41] = Card(JACK, CLUBS);
        cards[42] = Card(JACK, DIAMONDS);
        cards[43] = Card(JACK, SPADES);
        cards[44] = Card(QUEEN, HEARTS);
        cards[45] = Card(QUEEN, CLUBS);
        cards[46] = Card(QUEEN, DIAMONDS);
        cards[47] = Card(QUEEN, SPADES);
        cards[48] = Card(KING, HEARTS);
        cards[49] = Card(KING, CLUBS);
        cards[50] = Card(KING, DIAMONDS);
        cards[51] = Card(KING, SPADES);
        
        for (int i = 0; i < DECKSIZE; i++)
        {
            cardsUsed[i] = false;
        }
        totalUsed = 0;
        
        //Seed the random number generator.
        unsigned seed = static_cast<unsigned>(time(0));
        srand(seed);
    }
    
    //Modifiers
    
    //Deal a new card.
    Card Dealer::dealCard()
    {
        Card c;
        
        //If no cards left.
        if (totalUsed >= DECKSIZE)
        {
            throw std::logic_error("Out of cards.");
        }
        else
        {
            int index = 0;
            
            //Choose a card not yet dealt.
            do {
                index = rand() % DECKSIZE;
            } while (cardsUsed[index] == true);
            
            c = cards[index];
            cardsUsed[index] = true;
            totalUsed++;
        }
        
        return c;
    }
    
    //Reset deck.
    void Dealer::shuffleDeck()
    {
        for (int i = 0; i < DECKSIZE; i++)
        {
            cardsUsed[i] = false;
        }
        totalUsed = 0;
    }
}