//
//  CS52_12_4132_1230718_AshleyZeldin
//
//  Ashley Zeldin
//  CS 52 Section 4132
//  December 13, 2015
//
//  Game.cpp
//
//  Modified from the version created by Howard Stahl on April 30, 2015.
//

#include "Game.h"

namespace CS52
{
    //Constructors
    
    //Default constructor.
    Game::Game()
    {
        hand = NULL;
        
        haveWon = false;
    }
    
    //Getters
    
    //Determination that game has been won.
    bool Game::won()
    {
        return haveWon;
    }
    
    //Determination that game has been lost.
    bool Game::lost()
    {
        return !haveWon;
    }
    
    //Modifiers
    
    //Initiate an instance of the game comparing suits of three randomly selected cards.
    void Game::play()
    {
        //Delete any existing hand, if not NULL.
        if (hand != NULL)
        {
            delete hand;
        }
        
        //Create a new hand; insodoing, the constructor shuffles the deck before dealing.
        hand = new ThreeCardHand();
        
        //Build the new hand.
        hand->buildHand();
        
        //Print the hand.
        std::cout << "Hand dealt: " << std::endl << * hand << std::endl;
        
        //Compare suits of cards in hand.
        for (int i = 0; i < hand->getSize(); i++)
        {
            Card card1 = hand->getCard(i);
            
            //Start comparison with next card in hand.
            for (int j = i + 1; j < hand->getSize(); j++)
            {
                Card card2 = hand->getCard(j);
                
                //Matching suits means game is lost.
                if (card1.getSuit() == card2.getSuit())
                {
                    haveWon = false;
                    break;
                }
                //Differing suits means game is won.
                else
                {
                    haveWon = true;
                }
            }
            
            if (!haveWon)
            {
                break;
            }
        }
    }
}