//
//  CS52_12_4132_1230718_AshleyZeldin
//
//  Ashley Zeldin
//  CS 52 Section 4132
//  December 13, 2015
//
//  Hand.cpp
//
//  Modified from the version created by Howard Stahl on April 30, 2015.
//

#include "Hand.h"

namespace CS52
{
    //Constructors (and Destructors)
    
    //Constructor with default value to create two-card hand.
    Hand::Hand(int size)
    {
        cards = new Card[size];
        this->size  = size;
        dealer.shuffleDeck();
    }
    
    //Destructor.
    Hand::~Hand()
    {
        delete [] cards;
    }
    
    //Getters
    
    //Return card at index.
    Card Hand::getCard(int index)
    {
        Card c;
        if (index < size && index >= 0)
        {
            c = cards[index];
        }
        else
        {
            throw std::logic_error("Index out of range.");
        }
        return c;
    }
    
    //Return number of cards in hand.
    int Hand::getSize()
    {
        return size;
    }
    
    //Modifiers
    
    //Draw cards into hand.
    void Hand::buildHand()
    {
        for(int i = 0; i < size; i++)
        {
            Card c = dealer.dealCard();
            cards[ i ] = c;
        }
    }
    
    //Operators
    
    //Overload insertion output operator.
    std::ostream& operator << (std::ostream & outs, const Hand & h)
    {
        for (int i = 0; i < h.size; i++)
        {
            outs << h.cards[i] << std::endl;
        }
        return outs;
    }
}
