//
//  CS52_12_4132_1230718_AshleyZeldin
//
//  Ashley Zeldin
//  CS 52 Section 4132
//  December 13, 2015
//
//  Hand.h
//
//  Modified from the version created by Howard Stahl on April 30, 2015.
//

#ifndef CS52_12_4132_1230718_AshleyZeldin_Hand_H
#define CS52_12_4132_1230718_AshleyZeldin_Hand_H

#include <iostream>
#include "Card.h"
#include "Dealer.h"

namespace CS52
{
    class Hand
    {
    public:
        
        //Constructors (and Destructors)
        
        //Constructor with default value to create two-card hand.
        Hand(int size = 2);
        
        //Destructor.
        ~Hand();
        
        //Getters
        
        //Return card at index.
        Card getCard(int index);
        
        //Return number of cards in hand.
        int getSize();
        
        //Modifiers
        
        //Draw cards into hand.
        void buildHand();
        
        //Operators
        
        //Overload insertion output operator.
        friend std::ostream & operator << (std::ostream & outs, const Hand & h);
        
    private:
        
        //A dealer sources the cards in the hand.
        Dealer dealer;
        
        //A pointer to the first card in the hand.
        Card * cards;
        
        //An integer to track the number of cards in the hand.
        int size;
    };
}

#endif
